/**
 * Copyright (c) 2010-2016, Abel Hegedus, IncQuery Labs Ltd.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.tooling.ui.queryresult;

import org.eclipse.viatra.query.runtime.api.IPatternMatch;

/**
 * @author Abel Hegedus
 */
@SuppressWarnings("all")
public interface IQueryResultViewModelListener {
  void matcherAdded(final QueryResultTreeMatcher<?> matcher);

  void matcherFilterUpdated(final QueryResultTreeMatcher<?> matcher);

  void matcherRemoved(final QueryResultTreeMatcher<?> matcher);

  void matchAdded(final QueryResultTreeMatcher<?> matcher, final IPatternMatch match);

  void matchUpdated(final QueryResultTreeMatcher<?> matcher, final IPatternMatch match);

  void matchRemoved(final QueryResultTreeMatcher<?> matcher, final IPatternMatch match);
}
